package l12_generics;

public class BoundsDemo {

	record Statistic<T extends Number>(T[] numbers) { // T is a subclass of Number

		public double average() {
			double sum = 0.0;
			for (T num : numbers) sum += num.doubleValue();
			return sum / numbers.length;
		}
	}

	public static void main(String[] args) {

		Integer[] intNumbers = {1, 2, 3, 4, 5};
		System.out.println("intNumbers average is " +
				new Statistic<>(intNumbers).average());

		Double[] doubleNumbers = {1.1, 2.2, 3.3, 4.4, 5.5};
		System.out.println("doubleNumbers average is " +
				new Statistic<>(doubleNumbers).average());

//		String[] strings = { "1", "2", "3", "4", "5" };
//		Statistic<String> sob = new Statistic<>(strings); // not subclass of Number
	}
}


