package l12_generics;

import utilities.RandomGenerators;

public class GenericArrays {

	record GenericNumber<T extends Number>(T number) {

		@Override
		public String toString() {
			return number.getClass().getName() + ": " + number;
		}
	}

	public static void main(String[] args) {

//	Can't create an array of type-specific generic references; unsafe (type	erasure)
//		GenericNumber<Number>[] genericNumberArray = new GenericNumber<Number>[5];	//	Wrong!
		GenericNumber<?>[] genericNumberArray = new GenericNumber<?>[5]; // OK

//	GenericNumberArray<?> (pronounced "collection of unknown"), that is,
//	a collection whose element type matches anything. It's called a wildcard type

		for (int i = 0; i < genericNumberArray.length; ++i) {
			genericNumberArray[i] =
				switch (RandomGenerators.getInt(2)) {
					case 0 -> new GenericNumber<>(RandomGenerators.getInt(100));
					case 1 -> new GenericNumber<>(RandomGenerators.getDouble(0., 10.));
					default -> null;
				};
		}
//		genericNumberArray[0] = new GenericNumber<>("12"); // error: not a Number

		for (GenericNumber<?> number : genericNumberArray) {
			System.out.println(number);
		}
	}
}
