public class GenericDemo {

	record GenericClass<T>(T t) {
		private String showType() {
			return "T: " + t.getClass().getName();
		}

		private String showValue() {
			return "value: " + t;
		}

		@Override
		public String toString() {
			return showType() + "\n" + showValue();
		}
	}

	record AnyClass(double x) {

		@Override
		public String toString() {
			return "" + x;
		}
	}

	public static void main(String[] args) {

		System.out.println(new GenericClass<>(88));
		System.out.println();

		System.out.println(new GenericClass<>(new AnyClass(12.34)));
		System.out.println();

		System.out.println(new GenericClass<>("Some text"));
		System.out.println();
	}
}
