package l12_generics;

//	Sometimes we don’t want the whole class to be parameterized,
//	in that case we can	create java generics method.

public class GenericMethodDemo {

	//	Determine if an object is in an array.
	private static <T> boolean isIn(T value, T[] array) {
		for (T t : array) {
			if (value.equals(t)) return true;
		}
		return false;
	}

	private static <T> void printIfIsIn(T value, T[] array) {
		System.out.println(value + " is " + (isIn(value, array) ?
			"" : "not ") + "in the array");
	}

	public static void main(String[] args) {

//	Use isIn() on Integers.
		Integer[] numbers = { 0, 1, 2, 3, 4, 5 };
		printIfIsIn(2, numbers);
		printIfIsIn(8, numbers);
		System.out.println();

//	Use isIn() on Strings.
		String[] strings = { "zero", "one", "two", "three", "four", "five" };
		printIfIsIn("one", strings);
		printIfIsIn("ten", strings);
		System.out.println();

// This compiles, since String & Integer have a common base class: Object
// If we want to avoid that we should use generic class explicitly
		printIfIsIn("one", numbers);
	}
}


