// you cannot make a static reference to non-static type T.
// The reason is the type parameter T can be replaced by any of the type argument.
// But static fields/methods are shared by all non-static objects of the class.

public class GenericMethodFixedDemo<T> {

	//	Determine if an object is in an array.
	boolean isIn(T value, T[] array) {
		for (T t : array) if (value.equals(t)) return true;
		return false;
	}

	void printIfIsIn(T value, T[] array) {
		System.out.println(value + " is " + (isIn(value, array) ? "" : "not ")
				+ "in the array");
	}

	public static void main(String[] args) {

//	Use isIn() on Integers.
		Integer[] numbers = { 0, 1, 2, 3, 4, 5 };
		GenericMethodFixedDemo<Integer> intDemo = new GenericMethodFixedDemo<>();
		intDemo.printIfIsIn(2, numbers);
		intDemo.printIfIsIn(8, numbers);
		System.out.println();

//	Use isIn() on Strings
		GenericMethodFixedDemo<String> stringDemo = new GenericMethodFixedDemo<>();
		String[] strings = { "zero", "one", "two", "three", "four", "five" };
		stringDemo.printIfIsIn("one", strings);
		stringDemo.printIfIsIn("ten", strings);
		System.out.println();

		// This will compile, but we have to say explicitly
		// that the type T is object. Better???
		GenericMethodFixedDemo<Object> objectDemo = new GenericMethodFixedDemo<>();
		objectDemo.printIfIsIn("one", numbers);
	}
}


